
#include "inkey.ch"
*-------------------------------------------
* 
*-------------------------------------------   
#define STARTCHR  "{"
#define ENDCHR    "}" 

FUNCTION Print_Form(mtext,pg_length,linewidth,margin,aFont )
LOCAL printline, oldtext, marker1, marker,TxtBuffer:="" ,LastChrSpace ,aElement := {}
LOCAL TenitiveRem := .F.,TempTxt:="",TempTxt2,Jindex,Wordwrap := .F.,IsSecCR,IsJump:=.F.,Findex:=1
LOCAL XStart,bErrBlock
PRIVATE currline, lines,page, Iindex, Xpos,X1,Ypos,TempCMD,MaxLines,lmargin,Linespacing,rmargin,NumberPages:=.F. 
PRIVATE A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z

   no_print := .F.
   * save screen areas messed with
   IF pg_length = NIL  
      pg_length := 55
   ENDIF
   MaxLines := pg_length
   IF margin = NIL  
      margin := 5
   ENDIF   
   lmargin := margin
   IF linewidth = NIL  
      linewidth := 85 
   ENDIF
   linewidth := linewidth - lmargin
   rmargin := linewidth
   LineSpacing := 1      // default vertical spacing
   page := 1
   *** begin main loop
   currline := 1                    
   Iindex := 1
   Xpos := lmargin
   Xstart := Xpos
   Ypos := 1
   LastChrSpace := .F.
   temptxt := ""
   mtext   := STRTran(mtext,CHR(10),"")   // get rid of linefeeds their in the way
   DO WHILE Iindex <= LEN(mtext)

      DO CASE
         CASE ASC(mtext[Iindex]) = K_SPACE .AND. LastChrSpace
            LastChrSpace := .F. 
            IF !EMPTY(TempTxt)
               X1 := Xpos-FontHMetric(TempTxt,aFont[Findex])
               IF X1 < lmargin +1.4
                  X1 := lmargin
               ENDIF   
//               TxtAdjust(@aElement,@XStart,@Ypos,aFont)
               AADD(aElement,{"TXT",page,{Ypos,Xstart},TempTxt,Findex})
               TempTxt := ""
            ENDIF   
            DO WHILE ASC(mtext[Iindex]) = K_SPACE .AND. Iindex<LEN(mtext)
               ++Iindex
               ++Xpos    //increment by space caracter
            ENDDO  
            Xstart := Xpos
            LOOP
         CASE ASC(mtext[Iindex]) = K_SPACE
            LastChrSpace := .T.
            IF !EMPTY(temptxt)
               temptxt += mtext[Iindex] 
            ENDIF   
            Xpos += FontHMetric(" ",aFont[Findex])
         CASE mtext[Iindex] = STARTCHR
            //Start command
//            LastChrSpace := .F. 
            IsJump := ProcessCmd(@TempTxt,@mtext,@Iindex,@aElement,@Xpos,@Ypos,@page,lmargin,aFont,rmargin,@Findex,.F.,@Xstart)
         CASE (Iindex<LEN(mtext)-1 .AND. mtext[Iindex] = "!" .AND. mtext[Iindex+1] = "*") .OR. IsJump
            IsJump := .F.
            //Start rem
            LastChrSpace := .F. 
            IF !EMPTY(TempTxt)
               X1 := Xpos-FontHMetric(TempTxt,aFont[Findex])
               IF X1 < lmargin +1.4
                  X1 := lmargin
               ELSE
//                  TxtAdjust(@aElement,@X1,@Ypos,aFont)
               ENDIF
               AADD(aElement,{"TXT",page,{Ypos,Xstart},TempTxt,Findex})
               TempTxt := ""
            ENDIF
            DO WHILE Iindex<= LEN(mtext) .AND. ASC(mText[Iindex]) != K_RETURN
               IF mtext[Iindex] = STARTCHR
                  IF ProcessCmd(@TempTxt,@mtext,@Iindex,@aElement,@Xpos,@Ypos,@page,lmargin,aFont,rmargin,@Findex,.T.,@Xstart)
                     EXIT  // last cmd was a jump
                  ENDIF
               ENDIF
               ++Iindex
            ENDDO   
//            --Iindex  // let return section deal with it
            Xpos := lmargin   //Start of new line 
            Xstart := xpos
//            LOOP
         CASE ASC(mtext[Iindex]) = K_RETURN
            // end of line
            IF !EMPTY(TempTxt)
               IF Xpos >= rmargin
                  Jindex := LEN(TempTxt)
                  TempTxt2 := ""
                  DO WHILE Xpos >= rmargin .OR.( Jindex > 0 .AND. ASC(Temptxt[Jindex]) != K_SPACE )
                     TempTxt2 := Temptxt[Jindex]+TempTxt2
                     TempTxt  := LEFT(TempTxt,LEN(TempTxt)-1)
//                     Xpos -= FontHMetric(mtext[Jindex],aFont[Findex])
                     --Jindex
                     IF Jindex = 0 
                        EXIT
                     ENDIF    
                  ENDDO
                  Xpos := Xstart  //Xpos-FontHMetric(Temptxt,aFont[Findex])
                  IF Xpos < lmargin +1.4
                     Xpos = lmargin
                  ENDIF                   
                  IF !EMPTY(TempTxt)
//                     TxtAdjust(@aElement,@Xpos,@Ypos,aFont)
                     AADD(aElement,{"TXT",page,{Ypos,Xstart},TempTxt,Findex})
                     TempTxt := ""
                  ENDIF   
                  Ypos += LineSpacing
                  Xpos := lmargin  // start a new line  
                  Xstart := Xpos
                  TempTxt := lTRIM(TempTxt2) 
               ELSE 
                  X1 := Xpos-FontHMetric(TempTxt,aFont[Findex])
                  IF X1 < lmargin +1.4
                     X1 := lmargin
                  ENDIF   
//                  TxtAdjust(@aElement,@Xpos,@Ypos,aFont)
                  AADD(aElement,{"TXT",page,{Ypos,Xstart},TempTxt,Findex})
                  TempTxt := ""
               ENDIF   
            ENDIF
            IF !WordWrap
               Ypos += LineSpacing
               Xpos := lmargin   //Start of new line
               Xstart := Xpos
            ELSE
               // look forward
               Jindex := Iindex+1
               IsSecCR := .T.
               DO WHILE ASC(mText[Jindex]) != K_RETURN .AND. Jindex < LEN(mtext)
                  IF ASC(mtext[Jindex]) != K_SPACE
                     IsSecCR := .F.
                     EXIT
                  ENDIF  
                  ++Jindex
               ENDDO
               IF IsSecCR
                  Iindex := Jindex+1
//                  ++Ypos
                  Ypos += LineSpacing
                  Xpos := lmargin 
                  Xstart := Xpos
               ENDIF
            ENDIF
            LastChrSpace := .F. 
         OTHERWISE   // its text
            LastChrSpace := .F. 
            IF ASC(mtext[Iindex]) > K_SPACE
               TempTxt += mtext[Iindex]             
               Xpos := Xstart + FontHMetric(TempTxt,aFont[Findex])                
               IF ! EMPTY(TempTxt)
                  IF Xpos >= rmargin
                     Jindex := LEN(TempTxt)
                     TempTxt2 := ""
                     DO WHILE Xpos >= rmargin .OR.( Jindex > 0 .AND. ASC(Temptxt[Jindex]) != K_SPACE )
                        TempTxt2 := Temptxt[Jindex]+TempTxt2
                        TempTxt  := LEFT(TempTxt,LEN(TempTxt)-1)
                        Xpos := FontHMetric(TempTxt,aFont[Findex])
                        --Jindex
                        IF Jindex = 0 
                           EXIT
                        ENDIF    
                     ENDDO
                     Xpos := Xstart+FontHMetric(Temptxt,aFont[Findex])
                     IF Xpos < lmargin +1.4
                        Xpos = lmargin
                     ENDIF                   
                     IF !EMPTY(TempTxt)
//                        TxtAdjust(@aElement,@Xstart,@Ypos,aFont)
                        AADD(aElement,{"TXT",page,{Ypos,Xstart},TempTxt,Findex})
                        TempTxt := ""
                     ENDIF   
                     Ypos += LineSpacing   
                     IF TempTxt2[1] = " "
                        TempTxt2 := RIGHT(Temptxt2,LEN(TempTxt2)-1)
                     ENDIF
                     Xpos := lmargin + FontHMetric(TempTxt2,aFont[Findex]) // start a new line 
                     Xstart := lmargin
                     TempTxt := TempTxt2 
                  ENDIF   
               ENDIF
            ENDIF   
      ENDCASE
      ++Iindex
      IF Ypos > MaxLines
         IF Len(TempTxt) > 0
            X1 := Xpos-FontHMetric(TempTxt,aFont[Findex])
            IF X1 < lmargin +1.4
               X1 := lmargin
            ENDIF   
            AADD(aElement,{"TXT",page,{Ypos,Xstart},TempTxt,Findex})
            TempTxt := ""
         ENDIF
         // start new page
         Ypos := 3
         Xpos := lmargin
         Xstart := Xpos 
         ++Page
      ENDIF
   ENDDO
   IF Len(TempTxt) > 0   // catch last element
      X1 := Xpos-FontHMetric(TempTxt,aFont[Findex])
      IF X1 < lmargin +1.4
         X1 := lmargin
      ENDIF   
      AADD(aElement,{"TXT",page,{Ypos,XStart},TempTxt,Findex})
      TempTxt := ""
   ENDIF
   // Ok that should format it all, printit!!
   Iindex := 1
   Page := 1
   DO WHILE Iindex <= LEN(aElement)
      IF aElement[Iindex,2]!=Page
         Printer_EJECT()
         Page := aElement[Iindex,2] 
         IF NumberPages
            PrnVarCenter(MaxLines+1,Page,aFont[1])
         ENDIF   
      ENDIF
      IF aElement[Iindex,1]="TXT" 
         // check for text overlap
         Jindex := Iindex -1
         IF Jindex > 0
            DO WHILE Jindex > 0 .AND. aElement[Len(aElement),1]!="TXT"
               --Jindex
            ENDDO 
            IF Jindex > 0
               DO While aelement[Jindex,1]="TXT" .AND. aElement[Iindex,3][1] = aElement[Jindex,3][1] .AND. aElement[Iindex,3][2] < FontHMetric(aElement[Jindex,4],aFont[aElement[Jindex,5]])+aElement[Jindex,3][2]+FontHMetric(" ",aFont[aElement[Jindex,5]])
                  aElement[Iindex,3][2] += .1*FontHMetric(" ",aFont[aElement[Jindex,5]])
               ENDDO
            ENDIF
         ENDIF  
         SetFont(aFont[aElement[Iindex,5]])
         PrnVar(aElement[Iindex,3],aElement[Iindex,4])
      ELSEIF aElement[Iindex,1]="FONT"
         SetFont(aFont[aElement[Iindex,4]])
      ELSEIF aElement[Iindex,1]="PIC"
         PrnPic(aElement[Iindex,4],aElement[Iindex,3],aElement[Iindex,5])
      ENDIF
      ++Iindex   
   ENDDO
   
RETURN NIL


FUNCTION ProcessCmd(TempTxt,mtext,Iindex,aElement,Xpos,Ypos,page,margin,aFont,linewidth,Findex,IsRem,Xstart)
LOCAL X1,TempCMD,Jindex,temp,temp2,lRtn := .F.,Cfile,cFtxt,Mindex,bErrBlock,nVal1,nVal2
   //Start command
   LastChrSpace := .F. 
   IF !EMPTY(TempTxt)
/*      X1 := Xpos-FontHMetric(TempTxt,aFont[Findex])
      IF X1 < margin +1.4
         X1 := margin
      ELSE
         TxtAdjust(@aElement,@Xpos,@Ypos,aFont)
      ENDIF */   
      AADD(aElement,{"TXT",page,{Ypos,XStart},TempTxt,Findex})
      Xstart := Xstart + FontHMetric(TempTxt,aFont[Findex])
      Xpos := Xstart
      TempTxt := ""
   ENDIF 
   TempCMD := ""  
   ++Iindex
   DO WHILE mtext[Iindex] != ENDCHR
      TempCMD += mtext[Iindex]
      ++Iindex
      IF ASC(mtext[Iindex]) = K_RETURN .OR. (mtext[Iindex] = "!" .AND. mtext[Iindex+1] = "*")
         MPMMsgBox("ERROR - ill formed command in FORM"+TempCMD,"ERROR")
         RETURN lRtn
      ENDIF
   ENDDO  
   IF TempCMD[1] = "*"     // form command
      DO CASE 
         CASE "*F"$TempCMD  //font select
            IF IsDigit(TempCMD[3])
               Findex := Val(RIGHT(TempCMD,Len(TempCMD)-2))
               IF Findex <= LEN(aFont) .AND. Findex > 0 
                  AADD(aElement,{"FONT",page,{Ypos,Xpos},Findex})
               ELSE
                  Findex := 1
               ENDIF   
            ENDIF   
         CASE "*HTABC"$TempCMD  //Center Horizontal position
            IF IsDigit(TempCMD[7]).OR.IsDigit(TempCMD[8])
               temp := Val(RIGHT(TempCMD,Len(TempCMD)-6))
               Xpos := rmargin/2-temp/2   
            ELSE   
               bErrBlock := ErrorBlock( {|e| Break(e) } ) 
               BEGIN SEQUENCE
               temp := &(RIGHT(TempCMD,Len(TempCMD)-6))
               IF Valtype(temp) = "C" 
                  temp2 := rmargin/2 - FontHMetric(temp,aFont[Findex])/2
                  Xpos := temp2   
               ENDIF   
               RECOVER
                  MPMMsgBox("Syntex error in "+CHR(13)+TempCMD) 
               ENDSEQUENCE   
               ErrorBlock( bErrBlock ) 
            ENDIF   
         CASE "*HTAB"$TempCMD  //Horizontal position
            IF IsDigit(TempCMD[6]).OR.IsDigit(TempCMD[7])
               temp := Val(RIGHT(TempCMD,Len(TempCMD)-5))
               Xpos := temp   
            ELSE   
               bErrBlock := ErrorBlock( {|e| Break(e) } ) 
               BEGIN SEQUENCE
               temp := &(RIGHT(TempCMD,Len(TempCMD)-5))
               IF Valtype(temp) = "N"
                  Xpos := temp   
               ENDIF   
               RECOVER
                  MPMMsgBox("Syntex error in "+CHR(13)+TempCMD) 
               ENDSEQUENCE   
               ErrorBlock( bErrBlock ) 
            ENDIF   
         CASE "*VTAB"$TempCMD  //Vertical position
            IF IsDigit(TempCMD[6])
               temp := Val(RIGHT(TempCMD,Len(TempCMD)-5))
               Ypos := temp
            ELSE   
               bErrBlock := ErrorBlock( {|e| Break(e) } ) 
               BEGIN SEQUENCE
               temp := &(RIGHT(TempCMD,Len(TempCMD)-5))
               IF Valtype(temp) = "N"
                  Ypos := temp   
               ENDIF   
               RECOVER
                  MPMMsgBox("Syntex error in "+CHR(13)+TempCMD) 
               ENDSEQUENCE   
               ErrorBlock( bErrBlock ) 
            ENDIF   
         CASE "*J"$TempCMD  // jump to new location  marked by @string
            IF (Jindex:=AT(",",TempCMD))>0 
               temp := SubStr(TempCMD,Jindex+1)
               IF !EMPTY(temp)
                  bErrBlock := ErrorBlock( {|e| Break(e) } ) 
                  BEGIN SEQUENCE
                     IF &temp  // evaluate expression        
                        temp2 :=ALLTRIM(SubStr(TempCMD,3,Jindex-3)) 
                        Jindex:= AT("@"+temp2,mtext)
                        IF Jindex > 0
                           Iindex := Jindex
                           DO WHILE Iindex<LEN(mtext) .AND. ASC(mtext[Iindex])!=K_RETURN    // startagain at end of marked line 
                              ++Iindex
                           ENDDO 
                           Xpos := margin 
                           lRtn := .T.
                        ENDIF
                     ENDIF
                  RECOVER
                     MPMMsgBox("Syntex error in "+CHR(13)+TempCMD) 
                  ENDSEQUENCE   
                  ErrorBlock( bErrBlock ) 

               ENDIF
            ELSE  
               Jindex:= AT("@"+ALLTRIM(RIGHT(TempCMD,len(TempCMD)-2)),mtext)
               IF Jindex > 0
                  Iindex := Jindex
                  DO WHILE Iindex<LEN(mtext) .AND. ASC(mtext[Iindex])!=K_RETURN    // start again at end of marked line 
                     ++Iindex
                  ENDDO
                  Xpos := margin 
                  lRtn := .T.  
               ENDIF
            ENDIF
         CASE "*END"$TempCMD  //end printing
            Iindex := Len(mtext)             
         CASE "*TEXT"$TempCMD
            cFile := AllTRIM(RIGHT(TempCMD,Len(TempCMD)-5))
            IF FILE(DefaultPath+cFile)
               cFtxt := Memoread(DefaultPath+cFile) 
               cFtxt := Strtran(cFtxt,Chr(141)+Chr(10),"") // remove soft CR-LFs
               mtext := STUFF(mtext,Iindex+1,0,cFtxt)   
            ENDIF   
         CASE "*CENTER"$TempCMD
            temp := RIGHT(TempCMD,Len(TempCMD)-7)
         CASE "*PICT"$TempCMD
            temp := ALLTRIM(RIGHT(TempCMD,Len(TempCMD)-5))
            IF !EMPTY(temp)
               IF ","$temp   
                  nVal1 := Val(SUBSTR(temp,AT(",",temp)+1))
                  Temp2 := SUBSTR(Temp,AT(",",temp)+1)
                  nVal2 := Val(SubStr(temp2,AT(",",temp2)+1 ) )
                  IF nVal1 == 0 .OR. nVal2 == 0
                     MPMMsgBox("Syntex error in "+CHR(13)+TempCMD)
                     RETURN lRtn
                  ENDIF
                  cFile := RIGHT(temp,len(temp)-RAT(",",temp))
               ELSE
                  cFile := ""
                  MPMMsgBox("Syntex error in "+CHR(13)+TempCMD)                 
                  RETURN lRtn
               ENDIF
               IF FILE(cFile)
                  AADD(aElement,{"PIC",page,{Ypos,Xpos},cFile,{nVal1,nVal2}})
                  ++Ypos
                  IF Ypos > MaxLines
                     Ypos := 1
                     ++page
                  ENDIF
               ELSE
                  MPMMsgBox("Picture file "+cFile+" not found in "+CHR(13)+TempCMD)                      
               ENDIF
            ELSE
               MPMMsgBox("Syntex error in "+CHR(13)+TempCMD) 
            ENDIF
         CASE "*MEMO"$TempCMD
            bErrBlock := ErrorBlock( {|e| Break(e) } ) 
            BEGIN SEQUENCE
               temp := &(ALLTRIM(RIGHT(TempCMD,Len(TempCMD)-5)))
               FOR Mindex = 1 TO MLCOUNT(temp,rmargin*1.33) 
                  AADD(aElement,{"TXT",page,{Ypos,margin},MemoLine(Temp,rmargin*1.33,Mindex),Findex})
                  ++Ypos
                  IF Ypos > MaxLines
                     Ypos := 1
                     ++page
                  ENDIF                  
               NEXT             
            RECOVER
               MPMMsgBox("Syntex error in "+CHR(13)+TempCMD) 
            ENDSEQUENCE   
            ErrorBlock( bErrBlock ) 
         OTHERWISE
      ENDCASE    
   ELSE  // its a function 
      bErrBlock := ErrorBlock( {|e| Break(e) } ) 
      BEGIN SEQUENCE
         TempCMD := &("{ | | "+TempCMD+"}")
         temp := Eval(TempCMD)
      RECOVER
         temp  := " ERROR-SYNTEX IN FORM "+VAR2CHAR(TempCMD)
      ENDSEQUENCE   
      ErrorBlock( bErrBlock ) 

      DO CASE        // convert to string
         CASE ValType(temp) == "N"
            temp := STR(temp) 
         CASE ValType(temp) == "L"
            temp := IF(temp,"Yes","No") 
         CASE ValType(temp) == "D"
            temp := DTOC(temp) 
         CASE ValType(temp) == "A"
            temp := "ARRAY VARIABLE" 
         CASE ValType(temp) == "M"
            temp := "MEMO VARIABLE"
         CASE ValType(temp) == "C"
            temp := ALLTRIM(temp)
         OTHERWISE
            RETURN lRtn    
      ENDCASE 
      IF ! EMPTY(temp) .AND. !IsRem
         temptxt := temp
         IF Xpos+FontHMetric(temptxt,aFont[Findex]) >= rmargin
            Jindex := LEN(TempTxt)
            TempTxt2 := "" 
            DO WHILE Xpos+FontHMetric(TempTxt,aFont[Findex])>= rmargin .OR.( Jindex > 0 .AND. ASC(Temptxt[Jindex]) != K_SPACE )
               TempTxt2 := Temptxt[Jindex]+TempTxt2
               TempTxt  := LEFT(TempTxt,LEN(TempTxt)-1)
               --Jindex
               IF Jindex = 0 
                  EXIT
               ENDIF    
            ENDDO                   
            IF !EMPTY(TempTxt)
//               TxtAdjust(@aElement,@Xpos,@Ypos,aFont)
               AADD(aElement,{"TXT",page,{Ypos,Xstart},TempTxt,Findex})
               TempTxt := ""
            ENDIF   
            Ypos += LineSpacing
            Xpos := margin  // start a new line
            Xstart := Xpos
            IF !EMPTY(TempTxt2)
               AADD(aElement,{"TXT",page,{Ypos,Xstart},TempTxt2,Findex})
               Xpos += FontHMetric(TempTxt2,aFont[Findex]) // - IF(mtext[Iindex+1]=" " .OR. (mtext[Iindex+1]=STARTCHR.AND.mtext[Iindex+2]="*"),FontHMetric(" ",aFont[Findex]),0)
               Xstart := Xpos
            ENDIF   
         ELSE
//            TxtAdjust(@aElement,@Xpos,@Ypos,aFont)
            AADD(aElement,{"TXT",page,{Ypos,Xpos},TempTxt,Findex})
            Xpos += FontHMetric(TempTxt,aFont[Findex])// - IF(mtext[Iindex+1]=" " .OR. (mtext[Iindex+1]=STARTCHR.AND.mtext[Iindex+2]="*"),FontHMetric(" ",aFont[Findex]),0)
            Xstart := Xpos
            TempTxt := ""
         ENDIF 
      ENDIF
   ENDIF
RETURN lRtn

FUNCTION TxtAdjust(aElement,Xpos,Ypos,aFont)
LOCAL I,CalcPos1,CalcPos2
   I := LEN(aElement)
   DO WHILE I > 0 .AND. aelement[Len(aElement),1]!="TXT"
      --I
   ENDDO 
   IF I = 0
      RETURN Xpos
   ENDIF
   CalcPos1 := FontHMetric(aElement[I,4],aFont[aElement[I,5]])+aElement[I,3][2]+FontHMetric(" ",aFont[aElement[I,5]])
   CalcPos2 := FontHMetric(aElement[I,4],aFont[aElement[I,5]])+aElement[I,3][2]+3*FontHMetric(" ",aFont[aElement[I,5]])
   IF aelement[I,1]="TXT" .AND. Ypos = aElement[I,3][1] .AND. Xpos < CalcPos1
      Xpos := CalcPos1
   ENDIF
   IF aelement[I,1]="TXT" .AND. Ypos = aElement[I,3][1] .AND. Xpos > CalcPos1 .AND. Xpos < CalcPos2
      Xpos := CalcPos1
   ENDIF
RETURN Xpos

