**********************************************************************
*  Rev 1.30  6th.Oct.2002
******* CLICKDATE.CH  ************************************************
*
*  Common statics and defines for ClickDate.prg Calendar.
*
STATIC   aPos        := {nil,nil}
STATIC   aSize       := {nil,nil}
STATIC   dCurrDate
STATIC   dOrigDate
STATIC   lExitOk     := .F.
STATIC   lKillKeys   := .F.
STATIC   nCursorCol  := 0
STATIC   nCursorRow  := 0
STATIC   nDay        := 0
STATIC   nMonth      := 0
STATIC   nYear       := 0
STATIC   oAux       := NIL
STATIC   oAuxBox    := NIL
STATIC   oBtnBar
STATIC   oBtnTxt1
STATIC   oBtnTxt2
STATIC   oBtnTxt3
STATIC   oCal := NIL
STATIC   oCalBox := NIL
STATIC   oDate   := NIL
STATIC   oHelp   := NIL
STATIC   oHelp1  := NIL
STATIC   oHelp2  := NIL
STATIC   oKeyTrap
STATIC   oOpenUp  :=NIL
STATIC   oTitleBar:=NIL
STATIC   aBtnCaps:= ;
         {5001, 5002, 5003, 5004, 5005, 5006,5007,5008, 5009, 5010, 5011, 6000}
//       Today,Close,Select,Reset,Left,Right,Prev,Next,Minim,HelpO,HelpC, Calendar

#ifndef gdDTG
   #define gdDTG  25132800 // DeskTopGreen    GraMakeRGBColor({000,127,127})
   #define gdPBL  33545216 // Pastel Blue     GraMakeRGBColor({000,220,255})
   #define gdPPK  29935871 // Pastel Pink     GraMakeRGBColor({255,200,200})
   #define gdPGN  29949823 // Pastel Green    GraMakeRGBColor({200,255,200})
   #define gdPYL  29949951 // Pastel Yellow   GraMakeRGBColor({255,255,200})
   #define gdPMG  33540296 // Pastel Magenta  GraMakeRGBColor({200,200,255})
#endif

#define BGBITMAP 1015          // Background Bitmap number, if required.
#define FGC  GRA_CLR_BLACK     // Standard foreground colour.
//#define FGC  GRA_CLR_WHITE     // Standard foreground colour.
#define BGC  GRA_CLR_DARKRED   // Standard background colour.

#define CMINDATE "01/10/1752"  // Do not change sequence DD/MM/YYYY
***********************************************
* This is the _real_ September 1752
***********************
*    September 1752
***********************
*  S  M Tu  W Th  F  S
*        1  2 14 15 16
* 17 18 19 20 21 22 23
* 24 25 26 27 28 29 30
***********************

******* LANGUAGE DEFINITIONS  ************************************ ENGLISH
#ifdef ENGLISH
   #define FIR_ST       "st"  // as in '1st'
   #define SECO_ND      "nd"  // as in '2nd'
   #define THI_RD       "rd"  // as in '3rd'
   #define N_TH         "th"  // as in 'Nth'
   #define TEXT_DAY     "Day:"
   #define TEXT_WEEK    "Week:"
   #define TEXT_MONTH   "Month"
   #define TEXT_YEAR    "Year"
   #define TEXT_TODAY   "Today"
   #define YEAR_BASE    "01"     // First month of year (MM) e.g. "04" fiscal
   #define CENTURY_STAT ON             // Exit status for SET CENTURY...
   #define DATE_STATUS  BRITISH        // Exit state for SET DATE...
   #define DATE_FORMAT  "DD/MM/YYYY"   // Exit state for SET
   #define HELP_TITLE   "KeyBoard Help"
   #define HELP_TEXT1   " +Day-;"   +;
                        " +Week-;"  +;
                        " +Month-;" +;
                        " +Year-;"  +;
                        " +Year5-;" +;
                        " Min/Max;" +;
                        " Today;"   +;
                        " Original;"+;
                        " General"

   #define HELP_TEXT2   " Right / Left Arrow;"     +;
                        " Up / Down Arrow;"        +;
                        " PageUp / PageDown;"      +;
                        " Ctrl + PgUp / PgDn;"     +;
                        " Alt + PgUp / PgDn;"      +;
                        " Space / Ctrl + Space;"   +;
                        " Home key;"               +;
                        " End key;"                +;
                        " Enter, Rtn, Esc, F1"

   STATIC aMonths := {"January","Febuary","March","April","May","June",;
                      "July","August","September","October","November","December"}

   STATIC aDays   := {"Monday","Tuesday","Wednesday",;
                      "Thursday","Friday","Saturday","Sunday"}

   STATIC aDayBar := {" Mo"," Tu"," We"," Th"," Fr"," Sa"," Su"}
#endif

******* LANGUAGE DEFINITIONS  ************************************************

#ifdef ANOTHER_LANGUAGE
   ***** NOTE: CHANGE LANGUAGE DEFINE in CLICKDATE PROGRAM
   #define FIR_ST       "  "  // as in '1st' (MUST BE 2 CHARS ONLY)
   #define SECO_ND      "  "  // as in '2nd' (LEAVE BLANKS IF NOT USED)
   #define THI_RD       "  "  // as in '3rd'
   #define N_TH         "  "  // as in 'Nth'
   #define TEXT_DAY     ""
   #define TEXT_WEEK    ""
   #define TEXT_MONTH   ""
   #define TEXT_YEAR    ""
   #define TEXT_TODAY   ""
   #define YEAR_BASE    "01"     // First month of year (MM) e.g. "04" fiscal
   #define CENTURY_STAT ON             // Exit state for SET CENTURY...
   #define DATE_STATUS  BRITISH        // Exit state for SET DATE...
   #define DATE_FORMAT  "MM/DD/YYYY"   // Exit state for SET DATE FORMAT...
   #define HELP_TITLE   "Help"
   #define HELP_TEXT1   " +D-;"   +;
                        " +W-;"  +;
                        " +M-;" +;
                        " +Y-;"  +;
                        " +Y5-;" +;
                        "  /  ;" +;
                        "  ;"   +;
                        "  ;"+;
                        "   "

   #define HELP_TEXT2   " R / L Arrow;"     +;
                        " U / D Arrow;"        +;
                        " PU / PD;"      +;
                        " Ctrl + PU / PD;"     +;
                        " Alt + PU / PD;"      +;
                        " Space / Ctrl + Space;"   +;
                        " Home;"               +;
                        " End;"                +;
                        " Enter, Rtn, Esc, F1"

   STATIC aMonths := {"","","","","","",;
                      "","","","","",""}

   STATIC aDays   := {"","","","",;
                      "","",""}

   STATIC aDayBar := {"","","","","","",""}

#endif