/*
     Functions/Procedures to force picture entry in SLE's
     by James Loughner
        Made To Order Software
        10/1999
        email  jwrl@worldnet.att.net
        You may use this code freely but if you modify it you must send me
        a copy of the modified code or post it at AFAONLINE or Alaska Newgroup
        so others may benefit!  Thanks

    VERSION 1.1
       Its not exactly pictures but its alot better then the default SLE's
       and it easy to use.

    how to use
     Set
     oDlg:MYNUMSLE:keyboard := {|nKey,x,obj| SLENumeric(nKey,obj)}
     oDlg:MYDATE:keyboard := {|nKey,x,obj| SLEDate(nKey,obj)}
     etc....

     validate Date
     oDlg:MYDATE:KillInputFocus := {|x,y,obj| IF(SLEvalidateDate(obj),,SetAppFocus(obj))} 

     To use in FD forms make changes to the utilization prg the one without
     the '_' infront of its name.
 
     I think you can see what I'm doing so its not so hard to force any
     format on a SLE

     Now if I could just duplicate the @K function!
     Ok now I have. All procedures now work as if @K is set( pretty closly )
       WARNING The value in SLE must be the same length as the field or padded
               with spaces to the length of the SLE
               ie if loading a SLE form a DB DON'T trim the value. and the
                  length of the SLE must equal the length of the FIELD

     Now all process UPARROW DOWNARROW and ENTER work like Clipper gets

   FUNCTION/Procedures
   PROCEDURE SLENumeric(nKey,o)      // floating point numbers
   PROCEDURE SLEInteger(nKey,o)      // integer only
   PROCEDURE SLEDate(nKey,o)         //  mm/dd/yy or yy/mm/dd len 8 or 
                                         mm/dd/yyyy len 10

   PROCEDURE SLEMonthYear(nKey,o)    // MM/YY len 5  for credit cards etc
   PROCEDURE SLEPhone(nKey,o)        // phone format 999-9999   length 8
   PROCEDURE SLEPhonePerenth(nKey,o) // phone format (999)999-9999 length 13
   PROCEDURE SLEPhoneDash(nKey,o)    // phone format 999-999-9999   length 12
   PROCEDURE SLESSnumber(nKey,o)     // Social Security 999-99-9999   length 11
   PROCEDURE SLEZip(nKey,o)          // Zip format 99999
   PROCEDURE SLEZipLong(nKey,o)      // Zip 99999-999
   PROCEDURE SLETime(nKey,o)         // Time 99:99
   FUNCTION SLEvalidateDate(o)       // validate dates

   PROCEDURE SLEatK(nKey,o)          // emulatest @K for general strings 
   PROCEDURE SLELogical(nKey,o)      // emulatest @K for logical strings (Y/N)

*/
#include "Common.ch"
#include "Appevent.ch"
#include "Gra.ch" 
#include "Xbp.ch" 
#include "inkey.ch"
#include "Nls.ch"

// Error messages for date format errors. 
// You can translate these to your language
#define SLE_BADDATE_ERR1            "Bad date format! Month MM/DD/YY"
#define SLE_BADDATE_ERR2            "Bad date format! Day MM/DD/YY"
#define SLE_BADDATE_ERR3            "Bad date format! Month DD/MM/YY"
#define SLE_BADDATE_ERR4            "Bad date format! Day DD/MM/YY"
#define SLE_BADDATE_ERR5            "Bad date format! Month YYYY/MM/DD"
#define SLE_BADDATE_ERR6            "Bad date format! Month YY/MM/DD"
#define SLE_BADDATE_ERR7            "Bad date format! Day YYYY/MM/DD"
#define SLE_BADDATE_ERR8            "Bad date format! Day YY/MM/DD"
#define SLE_BADDATE_ERR9            "Bad date format! Missing Delimiter."
#define SLE_BADDATE_ERR0            "Bad date format! Unable to parse."



PROCEDURE SLENumeric(nKey,o,nlen,ndec) // floating point numbers
LOCAL nPos,cBuf
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. ((nKey >= 48 .AND. nKey <= 57).OR.CHR(nKey)="-".OR.CHR(nKey)=".")  //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = "."
      CASE CHR(nKey) = "-"
          cBuf := LEFT(LTRIM(o:EditBuffer()),1)
          IF cBuf!="-" .AND. LEN(o:EditBuffer()) < o:Bufferlength //  allow - as first character only
             RemoveCurrentChr(nKey,o)
          ENDIF
          IF nPos - 2 > 0 .AND. LEN(o:EditBuffer()) < o:Bufferlength
             cBuf := SubStr(o:EditBuffer(),nPos-2,1) // prev chara
             IF ASC(cBuf)>=48 .AND. ASC(cBuf)<=57 .OR. cBuf="-"  // trying to insert inside number
                RemoveCurrentChr(nKey,o)
             ENDIF
          ENDIF
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number 
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
   IF !EMPTY(nlen).AND. !EMPTY(ndec) .AND. !"."$o:EditBuffer()
      IF LEN(o:EditBuffer())>(nlen - ndec -1) 
         o:SetData(left(o:EditBuffer(),nlen - ndec -1)+"."+RIGHT(o:EditBuffer(),LEN(o:EditBuffer())-nlen + ndec +1)  )
         o:SetMarked({nPos+1,nPos+1})
      ENDIF
   ENDIF
RETURN

PROCEDURE SLEInteger(nKey,o)  // integer only
LOCAL nPos,cBuf
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND.((nKey >= 48 .AND. nKey <= 57).OR.CHR(nKey)="-")  //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = "-"
          cBuf := LEFT(LTRIM(o:EditBuffer()),1)
          IF cBuf!="-" .AND. LEN(o:EditBuffer()) < o:Bufferlength //  allow - as first character only
             RemoveCurrentChr(nKey,o)
          ENDIF
          IF nPos - 2 > 0 .AND. LEN(o:EditBuffer()) < o:Bufferlength
             cBuf := SubStr(o:EditBuffer(),nPos-2,1) // prev chara
             IF ASC(cBuf)>=48 .AND. ASC(cBuf)<=57 .OR. cBuf="-"  // trying to insert inside number
                RemoveCurrentChr(nKey,o)
             ENDIF
          ENDIF
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number 
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN

PROCEDURE SLEMove(nKey,o)  // use Clipper movement keys ie just add navigation keys
   DO CASE 
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   ENDCASE
RETURN

PROCEDURE ButtonMove(nKey,o)  // use Clipper movement keys ie just add navigation keys must be a button object
   DO CASE 
      CASE nKey = xbeK_RETURN
          IF o != NIL
             Eval(o:Activate)
          ENDIF   
      CASE nKey = xbeK_SPACE
          IF o != NIL
             Eval(o:Activate)
          ENDIF   
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
      OTHERWISE
//          PostAppEvent(xbeP_Keyboard,nKey,,o:SetParent())
   ENDCASE
RETURN

PROCEDURE ButtonMove2(nKey,o)  // use Clipper movement keys ie just add navigation keys must be a button object
   DO CASE 
      CASE nKey = xbeK_RETURN
          IF o != NIL
//             Eval(o:Activate)
          ENDIF   
      CASE nKey = xbeK_SPACE
          IF o != NIL
             Eval(o:Activate)
          ENDIF   
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
      OTHERWISE
//          PostAppEvent(xbeP_Keyboard,nKey,,o:SetParent())
   ENDCASE
RETURN

PROCEDURE SLEZip(nKey,o)  // Zip only  99999
LOCAL nPos
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. (nKey >= 48 .AND. nKey <= 57)  //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number 
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN


PROCEDURE SLEZipLong(nKey,o)  // Zip 99999-999
LOCAL nPos
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. (nKey >= 48 .AND. nKey <= 57)  //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number 
      CASE CHR(nKey) = "-"
          IF  nPos = 7
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN

// note needs modified if you use YYYY/MM/DD format
PROCEDURE SLEDate(nKey,o)  //  mm/dd/yy or yy/mm/dd len 8 or mm/dd/yyyy len 10
LOCAL nPos

   nPos := o:QueryMarked()[2]

   DO CASE 
      CASE nPos =1 .AND. (nKey >= 48 .AND. nKey <= 57) //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = SetLocale(NLS_SDATE) //date seperator from system
          IF nPos = 4 .OR. nPos = 7
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number in the space of seperator
          IF nPos = 4 .OR. nPos = 7  // modify to 6 and 9 for YYYY/MM/DD
             // number is in wrong place. Replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,SetLocale(NLS_SDATE)+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN

PROCEDURE SLEMonthYear(nKey,o) // MM/YY len 5  for credit cards etc
LOCAL nPos
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. (nKey >= 48 .AND. nKey <= 57) //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = SetLocale(NLS_SDATE) //date seperator from system
          nPos := o:QueryMarked()[2]
          IF nPos = 4 
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number in the space of seperator
          nPos := o:QueryMarked()[2]
          IF nPos = 4 
             // number is in wrong place. Replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,SetLocale(NLS_SDATE)+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN

 

PROCEDURE SLEPhone(nKey,o) // used for phone format 999-9999   length 8
LOCAL nPos
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. (nKey >= 48 .AND. nKey <= 57) //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = "-"
          nPos := o:QueryMarked()[2]
          IF nPos = 5 
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number in the space of seperator
          nPos := o:QueryMarked()[2]
          IF nPos = 5
             // number is in wrong place replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,"-"+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN

PROCEDURE SLETime(nKey,o) // used for time 99:99   Length 5
LOCAL nPos
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. (nKey >= 48 .AND. nKey <= 57) //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = ":"
          nPos := o:QueryMarked()[2]
          IF nPos = 4 
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number in the space of seperator
          nPos := o:QueryMarked()[2]
          IF nPos = 4
             // number is in wrong place replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,":"+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN


PROCEDURE SLEPhonePerenth(nKey,o) // used for phone format (999)999-9999   length 13
LOCAL nPos
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. ((nKey >= 48 .AND. nKey <= 57).OR. CHR(nKey)="(" ) //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = "("
          nPos := o:QueryMarked()[2]
          IF nPos = 2
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE CHR(nKey) = ")"
          nPos := o:QueryMarked()[2]
          IF nPos = 6
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE CHR(nKey) = "-"
          nPos := o:QueryMarked()[2]
          IF nPos = 10
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number in the space of seperator
          nPos := o:QueryMarked()[2]
          IF nPos = 2 
             // number is in wrong place replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,"("+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
          IF nPos = 6 
             // number is in wrong place replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,")"+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
          IF nPos = 10
             // number is in wrong place replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,"-"+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN


PROCEDURE SLEPhoneDash(nKey,o) // used for phone format 999-999-9999   length 12
LOCAL nPos
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. (nKey >= 48 .AND. nKey <= 57) //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = "-"
          nPos := o:QueryMarked()[2]
          IF nPos = 5 .OR. nPos = 9
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number in the space of seperator
          nPos := o:QueryMarked()[2]
          IF nPos = 5 .OR. nPos = 9
             // number is in wrong place replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,"-"+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN

PROCEDURE SLELogical(nKey,o) // emulatest @K for logical strings note SLE value must be padded to length of SLE
LOCAL nPos
   nPos := o:QueryMarked()[2]
    DO CASE
      CASE (nKey = 78 .OR. nKey = 110 .OR. nKey=89 .OR. nKey=121  ) // printable chars 
          IF nKey = 110
             nKey := 78
          ENDIF
          IF nKey = 121
             nKey := 89
          ENDIF
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
      CASE nKey = xbeK_TAB
      CASE nKey = xbeK_SH_TAB
      OTHERWISE
          RemoveCurrentChr(nKey,o)
   ENDCASE
RETURN

PROCEDURE SLESex(nKey,o) // M or F
LOCAL nPos
   nPos := o:QueryMarked()[2]
    DO CASE
      CASE (nKey = 77 .OR. nKey = 109 .OR. nKey=70 .OR. nKey=102  ) // printable chars 
          IF nKey = 109    // m
             nKey := 77
          ENDIF
          IF nKey = 102    // f
             nKey := 70
          ENDIF
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_TAB
      CASE nKey = xbeK_SH_TAB
      OTHERWISE
          RemoveCurrentChr(nKey,o)
   ENDCASE
RETURN

PROCEDURE SLEatK(nKey,o) // emulatest @K for general strings note SLE value must be padded to length of SLE
LOCAL nPos
   nPos := o:QueryMarked()[2]
    DO CASE
      CASE nPos =1 .AND. (nKey >= 32 .AND. nKey < 255  ) // printable chars 
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_TAB
      CASE nKey = xbeK_SH_TAB
   ENDCASE
RETURN

PROCEDURE ComboatK(nKey,o) // Combobox navigate keys
LOCAL nPos
   nPos := o:QueryMarked()[2]
    DO CASE
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_TAB
      CASE nKey = xbeK_SH_TAB
   ENDCASE
RETURN


PROCEDURE SLESSnumber(nKey,o)// used for Social Security 999-99-9999   length 12
LOCAL nPos
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. (nKey >= 48 .AND. nKey <= 57) //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = "-"
          nPos := o:QueryMarked()[2]
          IF nPos = 4 .OR. nPos = 7
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE (nKey >= 48 .AND. nKey <= 57)  // is a number in the space of seperator
          nPos := o:QueryMarked()[2]
          IF nPos = 5 .OR. nPos = 8 
             // number is in wrong place replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,"-"+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN 

PROCEDURE SLESSnumberExt(nKey,o)// used for Social Security 999-99-9999X   length 13
LOCAL nPos
   nPos := o:QueryMarked()[2]
   DO CASE 
      CASE nPos =1 .AND. (nKey >= 48 .AND. nKey <= 57) //@K funct
          o:SetData(CHR(nKey))
          o:SetMarked({2,2})
      CASE CHR(nKey) = "-"
          nPos := o:QueryMarked()[2]
          IF nPos = 4 .OR. nPos = 7
          ELSE
             // remove character if not in the right place
             RemoveCurrentChr(nKey,o)
          ENDIF
      CASE nPos < 12 .AND. (nKey >= 48 .AND. nKey <= 57)  // is a number in the space of seperator
          nPos := o:QueryMarked()[2]
          IF nPos = 5 .OR. nPos = 8 
            // number is in wrong place replace with delimiter plus number
             o:SetData(STUFF(o:EditBuffer(),nPos-1,2,"-"+CHR(nKey)))
             o:SetMarked({nPos+1,nPos+1})
          ENDIF
      CASE nPos >12 .AND. (nKey >= 32 .AND. nKey < 255  )
          RETURN
      CASE nKey = xbeK_CTRL_W
          PostAppEvent(xbeP_Keyboard,xbeK_ALT_S,,o)
      CASE nKey = xbeK_DEL
      CASE nKey = xbeK_BS
      CASE nKey = xbeK_RETURN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_DOWN
          PostAppEvent(xbeP_Keyboard,xbeK_TAB,,o)
      CASE nKey = xbeK_UP
          PostAppEvent(xbeP_Keyboard,xbeK_SH_TAB,,o)
   OTHERWISE
      RemoveNonNumChr(nKey,o)
   ENDCASE
RETURN 


FUNCTION SLEvalidateDate(o) 
LOCAL Rtn := .T.,cDate
   cDate := o:EditBuffer()
   IF EMPTY(CTOD(cDate))
      RETURN Rtn
   ENDIF
   DO CASE
      CASE Setlocale(NLS_IDATE)=="0"    // MM/DD/YY
         IF VAL(SUBSTR(cdate,1,2))=0 .OR. VAL(SUBSTR(cdate,1,2))>12
            MPMMsgBox(SLE_BADDATE_ERR1)
         ENDIF
         IF VAL(SUBSTR(cdate,4,2))=0 .OR. VAL(SUBSTR(cdate,4,2))>31
            MPMMsgBox(SLE_BADDATE_ERR2)
            Rtn := .F.
         ENDIF
      CASE Setlocale(NLS_IDATE)=="1"    // DD/MM/YY
         IF VAL(SUBSTR(cdate,4,2))=0 .OR. VAL(SUBSTR(cdate,4,2))>12
            MPMMsgBox(SLE_BADDATE_ERR3)
         ENDIF
         IF VAL(SUBSTR(cdate,1,2))=0 .OR. VAL(SUBSTR(cdate,1,2))>31
            MPMMsgBox(SLE_BADDATE_ERR4)
            Rtn := .F.
         ENDIF
      CASE Setlocale(NLS_IDATE)=="2"    // YY/MM/DD
         IF Setlocale(NLS_ICENTURY)=="1"  //YYYY
            IF VAL(SUBSTR(cdate,6,2))=0 .OR. VAL(SUBSTR(cdate,6,2))>12
               MPMMsgBox(SLE_BADDATE_ERR5)
            ENDIF
         ELSE                        //YY
            IF VAL(SUBSTR(cdate,6,2))=0 .OR. VAL(SUBSTR(cdate,6,2))>12
               MPMMsgBox(SLE_BADDATE_ERR6)
            ENDIF
         ENDIF
         IF Setlocale(NLS_ICENTURY)=="1"  //YYYY
            IF VAL(SUBSTR(cdate,9,2))=0 .OR. VAL(SUBSTR(cdate,9,2))>31
               MPMMsgBox(SLE_BADDATE_ERR7)
               Rtn := .F.
            ENDIF
         ELSE                       //YY
            IF VAL(SUBSTR(cdate,7,2))=0 .OR. VAL(SUBSTR(cdate,7,2))>31
               MPMMsgBox(SLE_BADDATE_ERR8)
               Rtn := .F.
            ENDIF
         ENDIF
   ENDCASE
   IF SUBSTR(cdate,3,1)!=Setlocale(NLS_SDATE)
      MPMMsgBox(SLE_BADDATE_ERR9)
      RETURN .F.
   ENDIF
   IF SUBSTR(cdate,3,1)!=Setlocale(NLS_SDATE) 
      MPMMsgBox(SLE_BADDATE_ERR9)
      RETURN .F.
   ENDIF                              
   IF Rtn .AND. EMPTY(CTOD(cDate))  // this catches errors like 31 days in feb
      MPMMsgBox(SLE_BADDATE_ERR0)
      RETURN .F.
   ENDIF
   IF !Rtn
     SetAppFocus(o)
   ENDIF
RETURN Rtn

STATIC PROCEDURE RemoveNonNumChr(nKey,o)
LOCAL nPos
   IF (nKey >= 32 .AND. nkey <= 47) .OR. (nKey >=58 .AND. nkey <=255)
      npos := IF(o:querymarked()[2]=1 ,1,o:querymarked()[2]-1)
      o:Setmarked({npos,npos+1})
      o:deletemarked()
      TONE(400) // let them know
   ENDIF
RETURN

STATIC PROCEDURE RemoveCurrentChr(nKey,o) 
LOCAL nPos
   npos := IF(o:querymarked()[2]=1 ,1,o:querymarked()[2]-1)
   o:Setmarked({npos,npos+1})
   o:deletemarked()
   TONE(400) // let them know
RETURN



