///////////////////////////////////////////////////////////////////////////////
//
//  Class code created by the Xbase++ FormDesigner
//    Creation date: 03/11/06 Creation time: 12:58:09
//
//  Contents  :
//    This file contains the implementation level of a form and is
//    overwritten automatically by the Xbase++ Form Designer.
//    Be careful when modifying this file since changes may get lost.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef _POPUPBROWSE_
#define _POPUPBROWSE_

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

#PRAGMA LIBRARY( "ASCOM10.LIB" )

CLASS _PopUpBrowse FROM XbpDialog
   EXPORTED:
      VAR editControls

      * Contained control elements
      VAR SeekString
      VAR BrowseBox 
      VAR SeekStatic
      VAR SeekPrompt
      VAR OkButton  
      VAR QuitButton
      VAR AddButton 
      VAR Aux1Button

      METHOD init
      METHOD create
ENDCLASS

******************************************************************************
* Initialize form
******************************************************************************
METHOD _PopUpBrowse:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {332,245}, ;
           aSize    TO {420,358}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )
   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "PopUpBrowse"

   ::editControls := {}

   ::SeekString := XbpSLE():new( ::drawingArea, , {68,300}, {104,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
   ::SeekString:tabStop := .T.

   ::BrowseBox  := XbpStatic():new( ::drawingArea, , {4,48}, {404,244} )
   ::BrowseBox:caption := "Group"
   ::BrowseBox:clipSiblings := .T.
   ::BrowseBox:type := XBPSTATIC_TYPE_BGNDRECT

   ::SeekStatic := XbpStatic():new( ::drawingArea, , {8,300}, {52,20}, { { XBP_PP_BGCLR, -255 } } )
   ::SeekStatic:caption := "Seek"
   ::SeekStatic:clipSiblings := .T.
   ::SeekStatic:options := XBPSTATIC_TEXT_BOTTOM+XBPSTATIC_TEXT_RIGHT

   ::SeekPrompt := XbpStatic():new( ::drawingArea, , {180,300}, {136,20}, { { XBP_PP_BGCLR, -255 } } )
   ::SeekPrompt:caption := ""
   ::SeekPrompt:clipSiblings := .T.
   ::SeekPrompt:options := XBPSTATIC_TEXT_VCENTER

   ::OkButton   := XbpPushButton():new( ::drawingArea, , {8,8}, {84,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::OkButton:caption := "&OK"
   ::OkButton:tabStop := .T.
   ::OkButton:activate := {|| NIL }

   ::QuitButton := XbpPushButton():new( ::drawingArea, , {100,8}, {84,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::QuitButton:caption := "&Quit"
   ::QuitButton:tabStop := .T.
   ::QuitButton:activate := {|| NIL }

   ::AddButton  := XbpPushButton():new( ::drawingArea, , {192,8}, {100,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::AddButton:caption := "&Add"
   ::AddButton:tabStop := .T.
   ::AddButton:activate := {|| NIL }

   ::Aux1Button := XbpPushButton():new( ::drawingArea, , {300,8}, {100,32}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::Aux1Button:caption := "Aux1"
   ::Aux1Button:tabStop := .T.
   ::Aux1Button:activate := {|| NIL }

RETURN self


******************************************************************************
* Request system resources
******************************************************************************
METHOD _PopUpBrowse:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::SeekString:create()

   ::BrowseBox:create()

   ::SeekStatic:create()

   ::SeekPrompt:create()

   ::OkButton:create()

   ::QuitButton:create()

   ::AddButton:create()

   ::Aux1Button:create()


RETURN self

#endif

//EOF
/////